/* Terraform - (C) 1997-1998 Robert Gasch (Robert_Gasch@peoplesoft.com)
 *  - www.peoplesoft.com/peoplepages/g/robert_gasch/terraform/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include "GuiDialogPreview.h"				// include gtk, gtk--
#include "GlobalTrace.h"


GuiDialogPreview::GuiDialogPreview (char *winTitle, char *frameTitle) : 
		  GuiDialogOAC ("GuiDialogPreview Test Dialog", "Test"),
		  d_vBoxList (TRUE, 5)
{
	d_preview = NULL;
	buildDialogWindow ();
	
}


GuiDialogPreview::~GuiDialogPreview ()
{
	if (d_preview)
		delete d_preview;
}


void GuiDialogPreview::fillVBox ()
{
	int	size=100;
	guchar 	*row = new unsigned char [3*size];
	
	
	this->d_baseFrame->add (d_vBoxList);

	d_preview = new Gtk_Preview (GTK_PREVIEW_COLOR);
	d_preview->size (size, size);
	d_vBoxList.pack_start (*d_preview, TRUE, TRUE, 3);
	d_preview->show ();
	d_vBoxList.show ();

/*
	for (int i=0; i<size; i++)
	   for (int j=0; j<size; j++)
		{
		row[j*3]=(int) (255.0/size*i);
		row[j*3+1]=(int) (255.0/size*i);
		row[j*3+2]=(int) (255.0/size*i);
		d_preview->draw_row (row, 0, i, size);
		}
*/

	delete [] row;
}


/*
 *  buildDialogWindow:
 */
void GuiDialogPreview::buildDialogWindow ()
{
	this->set_usize (200, 250);
	this->set_title (this->d_winTitle);

	this->get_vbox()->set_border_width (2);

	this->setupVBox ();
	fillVBox ();
	fillActionArea ();

	this->d_baseFrame->show ();
	this->show ();
}


void GuiDialogPreview::buttonCallbackOK ()
{	
	this->hide ();
	gdk_flush ();
	buttonCallbackApply ();
}


/*
 *  buttonCallbackApply: rotate the Height Field
 */
void GuiDialogPreview::buttonCallbackApply ()
{
}


gint GuiDialogPreview::delete_event_impl (GdkEventAny *)
{
	this->hide ();
	return (0);
}


/*
int GlobalTrace::s_traceLevel = 255;
int main (int argc, char *argv[])
{
	Gtk_Main        gtkMain (&argc, &argv);
	GuiDialogPreview *testDialog;

	testDialog = new GuiDialogPreview ();
	testDialog->show ();
	gtkMain.run ();
}
*/
